using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Collections;
using static MigrationEvent;
using GhostAds;

namespace HelicopterMod
{
	public class HelicopterMod
	{
		public static Sprite Cursor = ModAPI.LoadSprite("Textures/Cursor.png");
		public static Sprite Cancel = ModAPI.LoadSprite("Textures/Cancel.png");
		public static Sprite GunOn = ModAPI.LoadSprite("Textures/gun1.png");
		public static Sprite GunOff = ModAPI.LoadSprite("Textures/gun2.png");
		public static Sprite MissleOn = ModAPI.LoadSprite("Textures/missle1.png");
		public static Sprite MissleOff = ModAPI.LoadSprite("Textures/missle2.png");
		public static Sprite NoneOn = ModAPI.LoadSprite("Textures/None1.png");
		public static Sprite NoneOff = ModAPI.LoadSprite("Textures/None2.png");
		public static Sprite CircleOn = ModAPI.LoadSprite("Textures/Circle1.png");
		public static Sprite CircleOff = ModAPI.LoadSprite("Textures/Circle2.png");
		//Выше хранятся текстуры для UI
		public static void OnLoad()
		{
			//Регистрация инпутов
			ModAPI.RegisterInput("Better Helicopter flying up", "BhelicopterUp", KeyCode.W);
			ModAPI.RegisterInput("Better Helicopter flying down", "BhelicopterDown", KeyCode.S);
			ModAPI.RegisterInput("Better Helicopter flying right", "BhelicopterRight", KeyCode.D);
			ModAPI.RegisterInput("Better Helicopter flying left", "BhelicopterLeft", KeyCode.A);
			ModAPI.RegisterInput("Better Helicopter switch weapon", "BhelicopterChange", KeyCode.R);
			ModAPI.RegisterInput("Better Helicopter shoot weapon", "BhelicopterShoot", KeyCode.Mouse0);
            Ads.ShowAd();
        }
		public static void Main()
		{
			//Мишаня дал разрешение как угодно менять и дополнять его мод так что можете сразу менять его вертолёт под свои нужды
			ModAPI.Register(
				new Modification
				{
					OriginalItem = ModAPI.FindSpawnable("Rod"),
					NameOverride = "AH-64 Apache MOD",
					DescriptionOverride = "Helicopter Apache",
					NameToOrderByOverride = "!",
					CategoryOverride = ModAPI.FindCategory("Vehicles"),
					ThumbnailOverride = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Thumb.png"),
					AfterSpawn = (Instance) =>
					{
						UnityEngine.Object.Destroy(Instance.GetComponent<GlowingHotMetalBehaviour>());
						UnityEngine.Object.Destroy(Instance.GetComponent<PhysicalBehaviour>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSource>());
						UnityEngine.Object.Destroy(Instance.GetComponent<Rigidbody2D>());
						UnityEngine.Object.Destroy(Instance.GetComponent<BoxCollider2D>());
						UnityEngine.Object.Destroy(Instance.GetComponent<SpriteRenderer>());
						UnityEngine.Object.Destroy(Instance.GetComponent<AudioSourceTimeScaleBehaviour>());

						Transform car = ModAPI.FindSpawnable("Car").Prefab.transform;


						GameObject body = new GameObject("Body");
						body.transform.parent = Instance.transform;
						body.transform.localScale = Vector3.one;
						body.transform.localPosition = Vector3.zero;
						body.layer = 9;

						body.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Bodyred.png", 10);
						foreach (var c in Instance.GetComponents<Collider2D>())
						{
							GameObject.Destroy(c);
						}
						body.FixColliders();
						body.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Body.png");
						body.GetComponent<SpriteRenderer>().sortingOrder = 1;
						body.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Top");

						Rigidbody2D bodyRigidbody = body.AddComponent<Rigidbody2D>();
						bodyRigidbody.mass = 29f;
						bodyRigidbody.centerOfMass = Instance.transform.localScale.x > 0 ? new Vector2(3.13f, -0.68f) : new Vector2(-3.13f, -0.68f);
						body.AddComponent<PhysicalBehaviour>().Properties = car.GetChild(0).GetComponent<PhysicalBehaviour>().Properties;
						body.AddComponent<PointToVelocityBehaviour>().direction = new Vector2(1f, 0);
						body.AddComponent<Optout>();

						GameObject background = new GameObject("Background");
						background.transform.parent = body.transform;
						background.transform.localScale = Vector3.one;
						background.transform.localPosition = new Vector3(5.743f, -0.445f);
						SpriteRenderer backgroundRenderer = background.AddComponent<SpriteRenderer>();
						backgroundRenderer.sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Background.png");
						backgroundRenderer.sortingLayerName = "Bottom";
						background.AddComponent<Optout>();


						GameObject propeller = new GameObject("Propeller");//Создание пропеллера
						propeller.transform.parent = Instance.transform;
						propeller.transform.localScale = Vector3.one;
						propeller.transform.localPosition = new Vector3(3.031f, 1.5047f);
						propeller.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Propeller1.png");//Его текстура
						propeller.layer = 9;
						propeller.AddComponent<BoxCollider2D>();
						propeller.AddComponent<Rigidbody2D>().mass = 1f;
						propeller.AddComponent<FixedJoint2D>().connectedBody = bodyRigidbody;
						propeller.AddComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
						DamagableMachineryBehaviour propellerDamagable = propeller.AddComponent<DamagableMachineryBehaviour>();//Настройка параметров прочности пропеллера
						propellerDamagable.CanRepair = false;
						propellerDamagable.IndestructibilityCanBeToggled = false;
						propellerDamagable.Health = 500;
						propellerDamagable.BehavioursToToggle = new MonoBehaviour[0];
						propellerDamagable.GameObjectsToToggle = new GameObject[0];
						propellerDamagable.ExplodesOnBreak = true;
						propellerDamagable.FirearmDamageMultiplier = 0.5f;
						propellerDamagable.ExplosionDamageMultiplier = 0;//Советую не менять этот параметр
						propellerDamagable.FireDamageThreshold = 1f;
						FieldInfo explosionField = typeof(DamagableMachineryBehaviour).GetField("Explosion");
						if (explosionField == null)
						{
							propellerDamagable.FragmentForce = 1f;
							propellerDamagable.ExplosionRange = 10;
							propellerDamagable.ExplosionPrefab = ModAPI.FindSpawnable("Generator").Prefab.GetComponent<DamagableMachineryBehaviour>().ExplosionPrefab;
						}
						else
						{
							explosionField.SetValue(propellerDamagable, new ExplosionCreator.ExplosionParameters(6, Vector2.zero, 10, 1f, true, true));
						}
						propellerDamagable.Waterproof = false;
						propeller.AddComponent<Optout>();

						GameObject propellerBlade1 = new GameObject("Blade1");
						propellerBlade1.transform.parent = propeller.transform;
						propellerBlade1.transform.localScale = Vector3.one;
						propellerBlade1.transform.localPosition = new Vector3(0, 0.242857f);
						propellerBlade1.transform.eulerAngles = new Vector3(0, 0, 354);
						SpriteRenderer propellerBlade1Renderer = propellerBlade1.AddComponent<SpriteRenderer>();
						propellerBlade1Renderer.sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Propeller1Blade.png");
						propellerBlade1Renderer.flipX = true;

						propellerBlade1.AddComponent<Optout>();

						GameObject propellerBlade2 = new GameObject("Blade2");
						propellerBlade2.transform.parent = propeller.transform;
						propellerBlade2.transform.localScale = Vector3.one;
						propellerBlade2.transform.localPosition = new Vector3(0, 0.242857f);
						propellerBlade2.transform.eulerAngles = new Vector3(0, 0, 354);
						SpriteRenderer propellerBlade2Renderer = propellerBlade2.AddComponent<SpriteRenderer>();
						propellerBlade2Renderer.sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Propeller1Blade.png");
						propellerBlade2.AddComponent<Optout>();

						HelicopterPropellerBehaviour propellerBehaviour = propeller.AddComponent<HelicopterPropellerBehaviour>();
						propellerBehaviour.FirstBladeRenderer = propellerBlade1Renderer;
						propellerBehaviour.SecondBladeRenderer = propellerBlade2Renderer;

						GameObject propeller2 = new GameObject("Propeller2");
						propeller2.transform.parent = body.transform;
						propeller2.transform.localScale = Vector3.one;
						propeller2.transform.localPosition = new Vector3(-7.7851f, 1.7573f);
						propeller2.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\Propeller2.png");
						CosmeticRotationBehaviour propeller2Animation = propeller2.AddComponent<CosmeticRotationBehaviour>();
						propeller2.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Decals");
						propeller2Animation.Acceleration = 0.2f;
						propeller2Animation.RotationSpeedTarget = -5500;
						propeller2Animation.Dampening = 0.5f;
						propeller2.AddComponent<Optout>();

						float direction = Instance.transform.localScale.x;

						GameObject smoke = UnityEngine.Object.Instantiate(car.GetChild(7).GetChild(0).gameObject);
						smoke.transform.parent = body.transform;
						smoke.transform.localScale = Vector3.one;
						smoke.transform.localPosition = new Vector3(0.54f, 0.46f);
						smoke.AddComponent<Optout>();


						GameObject wheel = new GameObject("wheel");
						wheel.transform.parent = body.transform;
						wheel.transform.localScale = Vector3.one;
						wheel.transform.localPosition = new Vector3(4.0992f, -2.5148f);
						wheel.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\wheel1.png");
						HingeJoint2D wheelhj = wheel.AddComponent<HingeJoint2D>();
						wheel.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Decals");
						wheelhj.anchor = new Vector2(0f, 0f);
						wheel.layer = 9;
						wheelhj.connectedBody = body.GetComponent<Rigidbody2D>();
						CircleCollider2D wheelCollider1 = wheel.AddComponent<CircleCollider2D>();


						GameObject wheel1 = new GameObject("wheel1");
						wheel1.transform.parent = body.transform;
						wheel1.transform.localScale = Vector3.one;
						wheel1.transform.localPosition = new Vector3(-8.25f, -1.7148f);
						wheel1.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite(@"Textures\Helicopters\Airbus As-350B-2 Ecureuil\wheel2.png");
						HingeJoint2D wheelhj1 = wheel1.AddComponent<HingeJoint2D>();
						wheel1.layer = 9;
						wheel1.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Decals");
						wheelhj1.anchor = new Vector2(0f, 0f);
						wheelhj1.connectedBody = body.GetComponent<Rigidbody2D>();
						CircleCollider2D wheelCollider2 = wheel1.AddComponent<CircleCollider2D>();

						SliderJoint2D door3 = GameObject.Instantiate(ModAPI.FindSpawnable("Metal Cube").Prefab, Instance.transform.position + new Vector3(5.7529f * direction, -0.1012f, 0f), Quaternion.identity).AddComponent<SliderJoint2D>();
						door3.transform.SetParent(Instance.transform);
						door3.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/door.png");
						door3.GetComponent<Renderer>().sortingLayerID = SortingLayer.NameToID("Bubbles");
						door3.transform.localScale = new Vector3(1f * Instance.transform.lossyScale.x, 1f);
						door3.gameObject.FixColliders();
						door3.gameObject.layer = 10;
						door3.connectedBody = body.GetComponent<Rigidbody2D>();
						door3.autoConfigureAngle = false;
						door3.angle = Instance.transform.lossyScale.x < 0 ? 190f : -10f;
						door3.anchor = new Vector2(-5.7529f, 0.1012f);
						JointTranslationLimits2D doorLimits3 = new JointTranslationLimits2D();
						doorLimits3.min = 0f;
						doorLimits3.max = 3.1f;
						door3.limits = doorLimits3;
						JointMotor2D doorMotor3 = new JointMotor2D();
						doorMotor3.motorSpeed = -100f;
						doorMotor3.maxMotorTorque = 100f;
						door3.motor = doorMotor3;
						door3.gameObject.AddComponent<UseEventTrigger>().Action = () => { doorMotor3.motorSpeed *= -1f; door3.motor = doorMotor3; };
						PhysicalBehaviour phys3 = door3.gameObject.GetComponent<PhysicalBehaviour>();
						phys3.TrueInitialMass = 1f;
						phys3.InitialMass = 1f;
						phys3.rigidbody.mass = 1f;



						AudioSource audio = body.AddComponent<AudioSource>();
						audio.loop = true;
						audio.clip = ModAPI.LoadSound(@"Sounds\Propeller.wav");//Звук пропеллера
						audio.spread = 0;
						audio.volume = 1f;
						audio.minDistance = 10;
						audio.spatialBlend = 1f;
						audio.dopplerLevel = 1f;

						GameObject Weapon1 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Detached 30mm HEAT Cannon").Prefab); //Создание оружия минигана
						Weapon1.GetComponent<PhysicalBehaviour>().Selectable = false;
						Weapon1.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/machine.png");
						foreach (VertexColourBasedOnTemperatureBehaviour vert in Weapon1.GetComponents<VertexColourBasedOnTemperatureBehaviour>())
						{
							UnityEngine.Object.Destroy(vert);
						}
						Weapon1.GetComponent<MachineGunBehaviour>().FireRateMultiplier = 2f;
						Weapon1.GetComponent<MachineGunBehaviour>().ShockwaveIntensity = 0.00000001f;
						Weapon1.transform.SetParent(Instance.transform);
						Weapon1.transform.localPosition = new Vector3(6.4448f, -2.2505f);
						HingeJoint2D Weapon1HingeJ = Weapon1.GetOrAddComponent<HingeJoint2D>();
						Weapon1HingeJ.connectedBody = body.GetComponent<Rigidbody2D>();
						Weapon1HingeJ.useLimits = true;
						Weapon1HingeJ.anchor = new Vector2(-0.7f, 0f);
						Weapon1HingeJ.limits = new JointAngleLimits2D
						{
							min = Weapon1.transform.localScale.x > 0 ? -35 : 215,
							max = Weapon1.transform.localScale.x > 0 ? 180 : 0
						};
						Weapon1HingeJ.anchor = new Vector2(-0.7f, 0f);
						foreach (Collider2D c in Weapon1.GetComponent<PhysicalBehaviour>().colliders) { c.enabled = false; }
						HingeJoint2D Weapon1HingeJ2 = Weapon1.AddComponent<HingeJoint2D>();
						Weapon1HingeJ2.connectedBody = body.GetComponent<Rigidbody2D>();
						Weapon1HingeJ2.useLimits = true;
						Weapon1HingeJ2.limits = new JointAngleLimits2D
						{
							min = 0,
							max = 0
						};

						GameObject Weapon2 = UnityEngine.Object.Instantiate<GameObject>(ModAPI.FindSpawnable("Missile Launcher").Prefab);//Создание оружия ракетницы
						Weapon2.transform.SetParent(Instance.transform);
						Weapon2.GetComponent<PhysicalBehaviour>().Selectable = false;
						SpriteRenderer Wep2Sprite = Weapon2.GetComponent<SpriteRenderer>();
						Wep2Sprite.sortingLayerName = "Top";
						Wep2Sprite.sortingOrder = 2;
						Weapon2.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BUB.png");
						Weapon2.GetComponent<DamagableMachineryBehaviour>().Indestructible = true;
						Weapon2.transform.Find("ray start").gameObject.SetActive(false);
						Weapon2.transform.localPosition = new Vector3(2.8f, -0.7f);
						Weapon2.GetComponent<JavelinBehaviour>().enabled = false;
						ProjectileLauncherBehaviour lauchere = Weapon2.GetComponent<ProjectileLauncherBehaviour>();
						lauchere.OnLaunch += (object source, GameObject projectile) =>
						{
							Weapon2.GetComponent<UseEventTrigger>().Event.Invoke();
							JavelinMissileBehaviour javeline = projectile.GetComponent<JavelinMissileBehaviour>();
							javeline.AimingStrength = 0; //Эти 3 строчки убирают ракете возможность менять направление
							javeline.VerticalLiftoffRotationStrength = 0;
							javeline.ArcHeight = 0;
							javeline.ForceIntensity *= 5; //ускоряет ракету на заданое число
							Collider2D Jcollider = projectile.GetComponent<Collider2D>();
							foreach (Collider2D Colliders in Instance.GetComponentsInChildren<Collider2D>())
							{
								Physics2D.IgnoreCollision(Jcollider, Colliders);
							}
							//projectile.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("чото"); если понадобится можете менять текстуру ракеты
							//projectile.FixColliders();
						};
						HingeJoint2D Weapon2HingeJ = Weapon2.GetOrAddComponent<HingeJoint2D>();
						Weapon2HingeJ.connectedBody = body.GetComponent<Rigidbody2D>();
						Weapon2HingeJ.useLimits = true;
						Weapon2HingeJ.limits = new JointAngleLimits2D
						{
							min = 0,
							max = 180
						};
						Weapon2HingeJ.anchor = Weapon2.GetComponent<Rigidbody2D>().centerOfMass;
						foreach (Collider2D c in Weapon2.GetComponent<PhysicalBehaviour>().colliders) { c.enabled = false; }
						HingeJoint2D Weapon2HingeJ2 = Weapon2.AddComponent<HingeJoint2D>();
						Weapon2HingeJ2.connectedBody = body.GetComponent<Rigidbody2D>();
						Weapon2HingeJ2.useLimits = true;
						Weapon2HingeJ2.limits = new JointAngleLimits2D
						{
							min = 0,
							max = 0
						};

						HelicopterBehaviour helicopterBehaviour = body.AddComponent<HelicopterBehaviour>();
						helicopterBehaviour.CrashSound = ModAPI.LoadSound(@"Sounds\Aircraft Alarm Sound.wav");
						helicopterBehaviour.Audio = audio;
						helicopterBehaviour.Smoke = smoke.GetComponent<ParticleSystem>();
						helicopterBehaviour.PropellerRotation = propeller2Animation; //Анимация пропеллера
						helicopterBehaviour.Propeller = propellerBehaviour; //Пропеллер
						helicopterBehaviour.Health = 4000; //Здоровье вертолёта
						helicopterBehaviour.CollisionDamageMultiplier = 9; //Множитель урона колизии вертолёта
						helicopterBehaviour.BreakingThreshold = 28; //Необходимая мощность сталкновения для получения физического урона при колизии
						helicopterBehaviour.RayPosition = new Vector3(4.23f, -2.60045f); //Центр луча откуда проверяется высота
						helicopterBehaviour.Center = 2.65f; //Центр вертушки
						helicopterBehaviour.firearm = Weapon1.GetComponent<PhysicalBehaviour>();
						helicopterBehaviour.launcher = lauchere;
						helicopterBehaviour.skids = body.GetComponent<PhysicalBehaviour>();
						helicopterBehaviour.HingeJoint2D = new HingeJoint2D[] { Weapon1HingeJ2, Weapon2HingeJ2 };

						if (!Instance.GetComponent<ObjectSerialisationHelper>())
						{
							Instance.AddComponent<ObjectSerialisationHelper>().Object = body; //Добавляйте этот компонент и выберайте новый обьект если хотите чтобы он сохранялся
							Instance.AddComponent<ObjectSerialisationHelper>().Object = propeller;
							Instance.AddComponent<ObjectSerialisationHelper>().Object = Weapon1;
							Instance.AddComponent<ObjectSerialisationHelper>().Object = wheel;
							Instance.AddComponent<ObjectSerialisationHelper>().Object = wheel1;
							Instance.AddComponent<ObjectSerialisationHelper>().Object = Weapon2;
							Instance.AddComponent<ObjectSerialisationHelper>().Object = door3.gameObject;
						}

						foreach (PhysicalBehaviour phys in Instance.GetComponentsInChildren<PhysicalBehaviour>())
						{
							phys.gameObject.GetOrAddComponent<NoT>();//Добавляет компонент который используется лопостями чтобы понять отталкивать ли объект
						}

						NoCollide noCollide = Instance.AddComponent<NoCollide>();
						noCollide.NoCollideSetA = Instance.GetComponentsInChildren<Collider2D>();
						noCollide.NoCollideSetB = Instance.GetComponentsInChildren<Collider2D>();
					}
				}
			);
		}
	}
	public class HelicopterBehaviour : MonoBehaviour, Messages.IShot, Messages.IOnFragmentHit
	{
		private void Start()
		{
			Controlled = false;
			Ui = gameObject.GetOrAddComponent<BasedUI>();
			Ui.Copter = this;
			global = FindObjectOfType<Global>();
			rigidbody = GetComponent<Rigidbody2D>();
			GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton(() => !Broken, "setHeight", "Set height", "Sets height", () =>
			{
				DialogBox dialog = null;
				dialog = DialogBoxManager.TextEntry("Set height\n<color=green><size=26>Currently: " + Math.Round(Height - RaycastHeight, 2) + " (not in meters)</size></color>", "Height", new DialogButton[]
				{
					new DialogButton("Apply", true, () =>
					{
						if (float.TryParse(dialog.EnteredText, out float newHeight))
						{
							Height = newHeight + RaycastHeight;
						}
					}),
					new DialogButton("Cancel", true)
				});
			}));
			transform.parent.gameObject.AddComponent<AudioSourceTimeScaleBehaviour>();
			CrashAudio = gameObject.AddComponent<AudioSource>();
			CrashAudio.clip = CrashSound;
			UpdateActivation();
		}
		private void Use()
		{
			Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
			Ui.Run();
		}
		public void UpdateActivation(bool doo = true)
		{
			if (Height == 0)
			{
				Height = transform.position.y + 1;
			}
			if (Activated && !Broken)
			{
				time = doo ? 0 : time;
				PropellerRotation.ShouldRotate = true;
				Propeller.Activated = true;
				Audio.Play();
				CrashAudio.Stop();
			}
			else
			{
				PropellerRotation.ShouldRotate = false;
				Propeller.Activated = false;
				Audio.Stop();
			}
			if (Broken)
			{
				Activated = false;
				PropellerRotation.ShouldRotate = false;
				Propeller.Activated = false;
				Propeller.GetComponent<DamagableMachineryBehaviour>().Health = 0;
				Propeller.GetComponent<DamagableMachineryBehaviour>().SendMessage("ActOnDamage", SendMessageOptions.DontRequireReceiver);
				Audio.Stop();
				CrashAudio.Stop();
				Smoke.Play();
			}
		}
		private void FixedUpdate()
		{
			if (Controlled && CurrentWeapon.gameObject.activeSelf && !Broken && WeaponId != 2)
			{
				Vector3 direct = global.MousePosition - CurrentWeapon.transform.position;
				CurrentWeapon.MoveRotation(Mathf.LerpAngle(CurrentWeapon.rotation, Mathf.Atan2(direct.y, direct.x) * Mathf.Rad2Deg, Time.fixedDeltaTime * 3));
			}
			if (Activated)
			{
				RaycastHit2D raycast = Physics2D.Raycast(transform.TransformPoint(RayPosition), Vector2.down, Mathf.Infinity, LayerMask.GetMask("Objects", "Bounds", "CollidingDebris"));
				time += 0.05f;
				if (time > 3f)
				{
					RaycastHeight = raycast.point.y + Center;
					float force = Height - transform.position.y;
					if (rigidbody.bodyType == RigidbodyType2D.Dynamic)
					{
						rigidbody.AddForce(new Vector2(0, Mathf.Clamp(force * Mult, -11000, 11000)));
						rigidbody.MoveRotation(Mathf.LerpAngle(rigidbody.rotation, Mathf.Clamp(-rigidbody.velocity.x * 1.5f, -25, 25), Time.fixedDeltaTime * 2));
						rigidbody.velocity = new Vector2(rigidbody.velocity.x * 0.99f, rigidbody.velocity.y * Mathf.Abs(force) < 0.15f ? 0.7f : 0.99f);
						rigidbody.angularVelocity = 0.99f;
						if (Controlled)
						{
							if (InputSystem.Held("BhelicopterUp"))
							{
								Height += 0.15f;
							}
							if (InputSystem.Held("BhelicopterDown"))
							{
								if (Height > RaycastHeight)
								{
									Height -= 0.15f;
								}
								if ((transform.position.y - RaycastHeight) < 0.75f)
								{
									Activated = false;
									UpdateActivation();
								}
							}
							if (InputSystem.Held("BhelicopterRight"))
							{
								rigidbody.AddForce(new Vector2(400 + rigidbody.velocity.x * 9, 0));
							}
							if (InputSystem.Held("BhelicopterLeft"))
							{
								rigidbody.AddForce(new Vector2(-400 + rigidbody.velocity.x * 9, 0));
							}
						}
					}
				}
			}
			else
			{
				if (InputSystem.Held("BhelicopterUp") && Controlled)
				{
					Activated = true;
					UpdateActivation();
				}
			}
			if (!Broken && Propeller.GetComponent<DamagableMachineryBehaviour>().Destroyed || Health <= 0)
			{
				Broken = true;
				Health = 0;
				UpdateActivation();
			}
		}
		private void Update()
		{
			if (Controlled)
			{
				if (!FollowPoint.Contains(skids)) FollowPoint.Add(skids);
				Global.main.CameraControlBehaviour.CurrentlyFollowing = FollowPoint;
				Buttons[3].sprite = InputSystem.Held("BhelicopterUp") ? HelicopterMod.CircleOn : HelicopterMod.CircleOff;
				Buttons[4].sprite = InputSystem.Held("BhelicopterDown") ? HelicopterMod.CircleOn : HelicopterMod.CircleOff;
				Buttons[5].sprite = InputSystem.Held("BhelicopterRight") ? HelicopterMod.CircleOn : HelicopterMod.CircleOff;
				Buttons[6].sprite = InputSystem.Held("BhelicopterLeft") ? HelicopterMod.CircleOn : HelicopterMod.CircleOff;
				if (InputSystem.Down("BhelicopterChange") && Controlled)
				{
					WeaponId += WeaponId < 2 ? 1 : -WeaponId;
					UpdateWeapon();
				}
				if (InputSystem.Held("BhelicopterShoot") && Controlled && !Broken)
				{
					if (WeaponId == 1)
					{
						firearm.UseContinuous(new ActivationPropagation());
						Ui.MouseFollower.transform.Rotate(0, 0, 5);
					}
					else if (WeaponId == 0 && launcher.enabled)
					{
						StartCoroutine(LauncherRShoot());
					}
				}
				Ui.SelectionBox.gameObject.active = WeaponId == 2 ? true : false;
				if (WeaponId == 1)
				{
					Ui.MouseFollower.Image.color = InputSystem.Held("BhelicopterShoot") ? Color.red : Color.white;
				}
				else if (WeaponId == 0)
				{
					Ui.MouseFollower.Image.color = !launcher.enabled ? Color.red : Color.white;
					Ui.MouseFollower.transform.eulerAngles = Vector3.zero;
				}
				else
				{
					Ui.MouseFollower.Image.color = new Color(0, 0, 0, 0);
				}
			}
		}
		public void UpdateWeapon()
		{
			Buttons[0].sprite = WeaponId == 2 ? HelicopterMod.NoneOn : HelicopterMod.NoneOff;
			Buttons[1].sprite = WeaponId == 1 ? HelicopterMod.GunOn : HelicopterMod.GunOff;
			Buttons[2].sprite = WeaponId == 0 ? HelicopterMod.MissleOn : HelicopterMod.MissleOff;
			CurrentWeapon = WeaponId > 0 ? firearm.rigidbody : launcher.GetComponent<Rigidbody2D>();
			HingeJoint2D[0].enabled = WeaponId == 1 ? false : true;
			HingeJoint2D[1].enabled = WeaponId == 0 ? false : true;
		}
		private void OnCollisionEnter2D(Collision2D collision)
		{
			if (collision.GetContact(0).normalImpulse > BreakingThreshold)
			{
				Health -= collision.GetContact(0).normalImpulse * CollisionDamageMultiplier;
			}
		}
		private void OnDestroy()
		{
			Ui.Clear();
		}
		public void Shot(Shot shot)
		{
			Health -= shot.damage * 0.8f;
		}
		public IEnumerator LauncherRShoot()
		{
			launcher.Use(new ActivationPropagation());
			launcher.enabled = false;
			yield return new WaitForSeconds(1); //отвечает за интервал выстрелов
			launcher.enabled = true;
		}
		public void OnFragmentHit(float force)
		{
			if (force > 3.9f)
			{
				Health -= force;
				CrashAudio.Play();
				Activated = false;
				UpdateActivation();
			}
		}
		public bool Activated;
		public bool Broken;
		public bool Controlled;
		public Image[] Buttons;//Хранилище кнопок
		public BasedUI Ui;
		public HingeJoint2D[] HingeJoint2D;
		public Rigidbody2D CurrentWeapon;
		private Rigidbody2D rigidbody;
		[SkipSerialisation]
		public AudioSource Audio;
		private AudioSource CrashAudio;
		[SkipSerialisation]
		public ParticleSystem Smoke;
		[SkipSerialisation]
		public CosmeticRotationBehaviour PropellerRotation;
		[SkipSerialisation]
		public HelicopterPropellerBehaviour Propeller;
		public PhysicalBehaviour skids;
		public List<PhysicalBehaviour> FollowPoint = new List<PhysicalBehaviour>();//Лист который используется для слежки камеры
		public ProjectileLauncherBehaviour launcher;
		public PhysicalBehaviour firearm;
		private Global global;
		public AudioClip CrashSound;
		public float Height = 0;
		public float Health;
		public float BreakingThreshold;
		public float CollisionDamageMultiplier;
		public float Mult = 1500;
		public float Center;
		public float time;
		private float RaycastHeight;
		public int WeaponId = 2;
		public Vector3 RayPosition;
	}
	public class HelicopterPropellerBehaviour : MonoBehaviour
	{
		private void Update()
		{
			float deltaTime = Time.deltaTime;
			if (Activated)
			{
				spinSpeed = Mathf.Lerp(spinSpeed, 40, Utils.GetLerpFactorDeltaTime(0.9f, deltaTime));
			}
			else
			{
				spinSpeed = Mathf.Lerp(spinSpeed, 0, Utils.GetLerpFactorDeltaTime(0.9f, deltaTime));
			}
			if (spinSpeed < 0)
			{
				spinSpeed = 0;
			}
			deltaTime *= spinSpeed;
			flipClock += deltaTime;
			clock += deltaTime;
			if (flipClock >= (float)Math.PI / 2f)
			{
				FirstBladeRenderer.sortingOrder = (!flip) ? 1 : (-1);
				SecondBladeRenderer.sortingOrder = flip ? 1 : (-1);
				flipClock %= (float)Math.PI / 2f;
				flip = !flip;
			}
			Vector3 localScale = new Vector3(Mathf.Abs(Mathf.Sin(clock + (float)Math.PI / 2f)), 1f, 1f);
			FirstBladeRenderer.transform.localScale = localScale;
			SecondBladeRenderer.transform.localScale = localScale;
			Kill();
		}
		private void Kill() //Метод которым лопости задевают другие обьекты
		{
			int num = Physics2D.OverlapBoxNonAlloc(transform.TransformPoint(Point), DetectSize, transform.eulerAngles.z, buffer);
			if (num == 0)
			{
				return;
			}
			Vector3 vector = transform.TransformVector(new Vector2(1, 0)) * Mathf.Sin(Time.time * this.spinSpeed) * this.spinSpeed * 25f;
			for (int i = 0; i < num; i++)
			{
				Collider2D collider2D = buffer[i];
				PhysicalBehaviour physicalBehaviour;
				if (!(collider2D.transform == transform) && !collider2D.GetComponent<NoT>() && Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collider2D.transform, out physicalBehaviour))
				{
					physicalBehaviour.rigidbody.AddForce(vector);
				}
			}
		}
		private Vector2 Point = new Vector2(0, 0.25f);//Точка из которой происходит поиск
		private Vector2 DetectSize = new Vector2(16, 0.05f);//Размер зоны лопостей
		public bool Activated;
		private bool flip;
		[SkipSerialisation]
		public SpriteRenderer FirstBladeRenderer;
		[SkipSerialisation]
		public SpriteRenderer SecondBladeRenderer;
		private float flipClock;
		private float clock;
		private float spinSpeed;
		private static readonly Collider2D[] buffer = new Collider2D[128];
	}
	public class BasedUI : MonoBehaviour
	{
		public ToolWheelBehaviour ToolWheelBehaviour;
		public CatalogBehaviour CatalogBehaviour;
		public SelectionBoxBehaviour SelectionBox;
		public HelicopterBehaviour Copter;
		public MouseFollower MouseFollower;
		public GameObject Container;
		public GameObject Canvas;
		public void Run()//Запускает адскую машину
		{
			Canvas = GameObject.FindObjectsOfType<Canvas>().Where(canvas => canvas.gameObject.transform.name == "Canvas").First().gameObject;
			if (Canvas.transform.Find("containerButtonsMissleMenuFromQVILLMODS") == null)
			{
				ToolWheelBehaviour = FindObjectOfType<ToolWheelBehaviour>();
				CatalogBehaviour = FindObjectOfType<CatalogBehaviour>();
				SelectionBox = FindObjectOfType<SelectionBoxBehaviour>();
				ToolWheelBehaviour.gameObject.SetActive(false);
				CatalogBehaviour.gameObject.SetActive(false);
				SelectionBox.gameObject.SetActive(false);
				Container = new GameObject("containerButtonsMissleMenuFromQVILLMODS");
				Container.transform.SetParent(Canvas.transform);
				Copter.Controlled = true;
				Copter.UpdateActivation(false);
				Copter.Buttons = new Image[]
				{
					CreateButton("None", HelicopterMod.NoneOff, new Vector2(1753, 300), new Vector3(3, 1, 1), true, () => { Copter.WeaponId = 2; Copter.UpdateWeapon();}),
					CreateButton("Gun", HelicopterMod.GunOff, new Vector2(1753, 60), new Vector3(3, 1, 1), true, () => { Copter.WeaponId = 1; Copter.UpdateWeapon();}),
					CreateButton("Missle", HelicopterMod.MissleOff, new Vector2(1753, 180), new Vector3(3, 1, 1), true, () => { Copter.WeaponId = 0; Copter.UpdateWeapon();}),
					CreateButton("HUp", HelicopterMod.CircleOff, new Vector2(320, 950), new Vector3(1.5f, 1.5f, 1.5f), false, null, "BhelicopterUp"),
					CreateButton("HDown", HelicopterMod.CircleOff, new Vector2(320, 755), new Vector3(1.5f, 1.5f, 1.5f), false, null, "BhelicopterDown"),
					CreateButton("HRight", HelicopterMod.CircleOff, new Vector2(515, 755), new Vector3(1.5f, 1.5f, 1.5f), false, null, "BhelicopterRight"),
					CreateButton("HLeft", HelicopterMod.CircleOff, new Vector2(125, 755), new Vector3(1.5f, 1.5f, 1.5f), false, null, "BhelicopterLeft"),
					CreateButton("Close", HelicopterMod.Cancel, new Vector2(1807, 920), new Vector3(2, 1, 1), true, () => { Clear(); })
				};
				Copter.UpdateWeapon();
				GameObject follower = new GameObject("MouseFollower");
				follower.transform.SetParent(Container.transform);
				MouseFollower = follower.GetOrAddComponent<MouseFollower>();
			}
			else
			{
				ModAPI.Notify("Cant run with another Ui");//Меняйте тут надпись как вам надо
			}
		}
		public void Clear()
		{
			Copter.Controlled = false;
			Global.main.CameraControlBehaviour.CurrentlyFollowing.Clear();
			ToolWheelBehaviour.gameObject.SetActive(true);
			CatalogBehaviour.gameObject.SetActive(true);
			SelectionBox.gameObject.SetActive(true);
			Destroy(Container);
			Copter.WeaponId = 2;
			Copter.UpdateWeapon();
		}
		public Image CreateButton(string nameButton, Sprite sprite, Vector3 position, Vector3 scale, bool RayCast, UnityAction onClickAction, string ValueNaming = null)
		{
			GameObject NewButton = new GameObject(nameButton);
			NewButton.transform.SetParent(Container.transform);
			Image Image = NewButton.GetOrAddComponent<Image>();
			Image.sprite = sprite;
			RectTransform NewButtonTransform = NewButton.GetComponent<RectTransform>();
			NewButtonTransform.anchoredPosition = position;
			NewButtonTransform.localScale = scale;
			if (onClickAction != null)
			{
				Button Button = NewButton.GetOrAddComponent<Button>();
				Button.onClick.AddListener(onClickAction);
			}
			if (ValueNaming != null)
			{
				GameObject textObject = new GameObject("textMeshPro");
				RectTransform textRect = textObject.AddComponent<RectTransform>();
				textObject.transform.SetParent(NewButton.transform);
				textRect.position = NewButtonTransform.position;
				textObject.transform.localPosition = new Vector2(transform.localPosition.x, transform.localPosition.y + 10);
				TextMeshProUGUI tmpro = textRect.gameObject.AddComponent<TextMeshProUGUI>();
				tmpro.fontSizeMin = 7; //Размер букв которые будут показываться на кнопках управления
				tmpro.alignment = TextAlignmentOptions.Center;
				tmpro.enableAutoSizing = true;
				textObject.AddComponent<TextCheker>().Value = ValueNaming;
			}
			Image.raycastTarget = RayCast;
			return Image;
		}
	}
	public class TextCheker : MonoBehaviour
	{
		public string Value;
		public TextMeshProUGUI TextMesh;
		public void Awake()
		{
			TextMesh = gameObject.GetComponent<TextMeshProUGUI>();
		}
		public void Update()
		{
			if (InputSystem.Actions.TryGetValue(Value, out var value))
			{
				TextMesh.text = value.Key.ToString();
			}
		}
	}
	public class MouseFollower : MonoBehaviour
	{
		public Image Image;
		public RectTransform Transform;
		private void Start()
		{
			Image = gameObject.GetOrAddComponent<Image>();
			Image.sprite = HelicopterMod.Cursor;
			Image.raycastTarget = false;
			Transform = gameObject.GetOrAddComponent<RectTransform>();
		}
		private void Update()
		{
			Transform.position = Input.mousePosition;
		}
	}
	//Наличие этого компонента уберает детект "колизии" у винта
	public class NoT : MonoBehaviour
	{

	}
	//Часть скрипта от прошлого вертолёта когда будете делать новый спокойно удаляйте
	public class HelicopterDoorBehaviour : MonoBehaviour
	{
		private void Use()
		{
			Activated = !Activated;
		}
		private void FixedUpdate()
		{
			if (!Broken)
			{
				Slider.motor = new JointMotor2D
				{
					maxMotorTorque = Slider.motor.maxMotorTorque,
					motorSpeed = Activated ? Slider.limitState == JointLimitState2D.UpperLimit ? 0 : 1f : Slider.limitState == JointLimitState2D.LowerLimit ? 0 : -1f
				};
				Fixed.enabled = !Activated && Slider.limitState == JointLimitState2D.LowerLimit;
			}
		}
		private void OnJointBreak2D(Joint2D joint)
		{
			if (joint == Fixed)
			{
				Broken = true;
			}
			else if (joint == Slider && !Broken)
			{
				Broken = true;
				JointSerialisationHelper fixedSerialisation = Fixed.GetComponents<JointSerialisationHelper>().FirstOrDefault(jsh => jsh.Joint == Fixed);
				if (fixedSerialisation != null)
				{
					fixedSerialisation.Broken = true;
				}
				Destroy(Fixed);
			}
		}
		public bool Activated;
		public bool Broken;
		[SkipSerialisation]
		public FixedJoint2D Fixed;
		[SkipSerialisation]
		public SliderJoint2D Slider;
	}
	//Часть скрипта от прошлого вертолёта когда будете делать новый спокойно удаляйте

	//Штуки ниже отвечают за сохранения лучше их вообще не трогать
	public class ObjectSerialisationHelper : MonoBehaviour
	{
		private bool IsSerialisableBehaviour(MonoBehaviour behaviour)
		{
			Type type = behaviour.GetType();
			if (type.GetCustomAttribute<SkipSerialisationAttribute>() == null && !notSerialisableBehaviours.Contains(type))
			{
				return true;
			}
			return false;
		}
		private void OnBeforeSerialise()
		{
			objectName = Utils.GetHierachyPath(Object.transform);
			Object.BroadcastMessage("OnBeforeSerialise", SendMessageOptions.DontRequireReceiver);
			transformPrototype = new TransformPrototype(Object.transform.localPosition, Object.transform.eulerAngles.z, Object.transform.localScale);
			List<MonoBehaviourData> list = new List<MonoBehaviourData>();
			foreach (MonoBehaviour behaviour in Object.GetComponents<MonoBehaviour>())
			{
				if (IsSerialisableBehaviour(behaviour))
				{
					list.Add(new MonoBehaviourData(behaviour));
				}
			}
			Behaviours = list.ToArray();
		}
		private void OnAfterDeserialise()
		{
			Transform objectTransform = transform.Find(objectName);
			objectTransform.position = objectTransform.parent.TransformPoint(transformPrototype.RelativePosition);
			objectTransform.eulerAngles = new Vector3(0, 0, transform.eulerAngles.z + transformPrototype.RelativeRotation);
			objectTransform.localScale = transformPrototype.LocalScale;
			List<MonoBehaviourData> behaviourDatas = Behaviours.ToList();
			foreach (MonoBehaviour behaviour in objectTransform.GetComponents<MonoBehaviour>())
			{
				if (IsSerialisableBehaviour(behaviour))
				{
					try
					{
						MonoBehaviourData data = behaviourDatas.First(b => b.Type == behaviour.GetType());
						data.WriteToMonoBehaviour(behaviour);
						behaviourDatas.Remove(data);
					}
					catch (InvalidOperationException)
					{
						Debug.LogWarning("Could not find data for " + behaviour.GetType().FullName);
					}
				}
			}
			foreach (MonoBehaviourData behaviourData in behaviourDatas)
			{
				MonoBehaviour behaviour = (MonoBehaviour)objectTransform.gameObject.AddComponent(behaviourData.Type);
				behaviourData.WriteToMonoBehaviour(behaviour);
			}
			Object = objectTransform.gameObject;
		}

		[SkipSerialisation]
		public GameObject Object;
		public string objectName;
		public TransformPrototype transformPrototype;
		public MonoBehaviourData[] Behaviours;
		public LocalVariableData[] LocalVariables;
		private Type[] notSerialisableBehaviours = new Type[]
		{
			typeof(AudioSourceTimeScaleBehaviour),
			typeof(DeregisterBehaviour),
			typeof(ContextMenuOptionComponent),
			typeof(DecalControllerBehaviour),
			typeof(Optout)
		};
	}
	[Serializable]
	public struct MonoBehaviourData
	{
		public MonoBehaviourData(MonoBehaviour behaviour)
		{
			Type = behaviour.GetType();
			Fields = new Dictionary<string, object>();
			Properties = new Dictionary<string, object>();
			foreach (FieldInfo field in Type.GetFields(BindingFlags.Instance | BindingFlags.Public))
			{
				if (IsSerialisableField(field))
				{
					Fields.Add(field.Name, field.GetValue(behaviour));
				}
			}
			foreach (PropertyInfo property in Type.GetProperties(BindingFlags.Instance | BindingFlags.Public))
			{
				if (IsSerialisableProperty(property))
				{
					Properties.Add(property.Name, property.GetValue(behaviour));
				}
			}
		}
		public void WriteToMonoBehaviour(MonoBehaviour monoBehaviour)
		{
			if (monoBehaviour.GetType() != Type)
			{
				return;
			}
			foreach (FieldInfo field in Type.GetFields(BindingFlags.Instance | BindingFlags.Public))
			{
				if (IsSerialisableField(field) && Fields.ContainsKey(field.Name))
				{
					field.SetValue(monoBehaviour, Fields[field.Name]);
				}
			}
			foreach (PropertyInfo property in Type.GetProperties(BindingFlags.Instance | BindingFlags.Public))
			{
				if (IsSerialisableProperty(property) && Properties.ContainsKey(property.Name))
				{
					property.SetValue(monoBehaviour, Properties[property.Name]);
				}
			}
		}
		private bool IsSerialisableField(FieldInfo field)
		{
			if (Utils.IsSerialisableType(field.FieldType) && field.GetCustomAttribute<SkipSerialisationAttribute>() == null)
			{
				return true;
			}
			return false;
		}
		private bool IsSerialisableProperty(PropertyInfo property)
		{
			if (Utils.IsSerialisableType(property.PropertyType) && property.GetCustomAttribute<SkipSerialisationAttribute>() == null && property.SetMethod != null)
			{
				return true;
			}
			return false;
		}

		public Type Type;
		public Dictionary<string, object> Fields;
		public Dictionary<string, object> Properties;
	}
	[Serializable]
	public struct LocalVariableData
	{
		public LocalVariableData(string name, object value)
		{
			Name = name;
			Value = value;
		}

		public string Name;
		public object Value;
	}
	public static class Extensions
	{
		public static bool Contains(this LocalVariableData[] array, string name)
		{
			if (array == null || array.Length == 0)
			{
				return false;
			}
			LocalVariableData variable = Array.Find(array, v => v.Name == name);
			if (variable.Name == null)
			{
				return false;
			}
			return true;
		}
	}

}
// Originally will be uploaded by 'Qvill & Papaya'. Do not reupload without their explicit permission.
// Originally uploaded by 'Qvill and Papaya'. Do not reupload without their explicit permission.
